Description

When using the time warp when flying a plane in the atmosphere it causes my parts to bend back and rotate as if i were flying at a
much faster speed. This is probably a huge contributing factor to the instability other people report using time warp.

To Reproduce:

Load ship. Activate stability SAS. Take off at half throttle using jet engines. Reach stable heading at 1000m altitude with about
100m/s airspeed. Turn so you are looking at the side of the plane. Slowly increase the time steps, 1x, 2x, 3x, 4x. You will see the
rocket engines bending back from the plane wing and the plane twisting backwards.

It looks like what ever routine is used to calculate the torsion is not grabbing the standard simulator velocity of the plane, but instead
calculating its own velocity by measuring the distance traveled between time steps, Vtorsion = (d2-d1) / Tstep, where Tstep is a
constant associated with the simulator running at 1x. The time step is likely larger for 2x, 3x, 4x, but the torsion calculator doesn't
account for this.

Anyway thats my guess why its doing this. I'm betting fixing this will fix alot of the random blow ups/gltiches of other people time
warping.

Related issues:
Is duplicate of Kerbal Space Program - Bug #3876: Speeding up the game speed ... Not a Bug 12/19/2014

History

#1 - 09/20/2015 11:50 AM - gsonnenf

Here is a video of it happening:

https://youtu.be/1g_4EZpIx9A

It is most clearly demonstrated at about 30s, when switching from 4x to 1x. You can clearly see the wing untwist.

#2 - 09/20/2015 04:31 PM - Summoners_Rift
- Category changed from 281 to Physics

- Status changed from New to Not a Bug

- Severity changed from High to Low

- % Done changed from 0 to 100

This is normal behavior. When you use physics warp, all of the numbers (lift, drag, thrust) are multiplied by that number, making some larger ships
and planes break easily under the multiplied stresses.

#3 - 09/20/2015 06:41 PM - gsonnenf

Time warp should increase the rate of in game time relative to real time, not increases stresses on parts.
Its always bizarre and maddening when you get a response of "Its not a bug, its a feature!"

Please do time acceleration correctly, at the very least don't multiply the effect that causes torsion.

#4 - 09/21/2015 11:58 AM - Ted
https://youtu.be/1g_4EZpIx9A

It's not a feature, you're right. But it's also not a bug that is unexpected and not one that can be fixed in the traditional sense. In fact, we try to
communicate this to the player with a dialog box informing them that the physics warp mode is inherently unstable and will cause large vessels to
come apart.

#5 - 09/21/2015 01:43 PM - Kosmognome

But it's also not a bug that is unexpected and not one that can be fixed in the traditional sense.

I'm curious as to why that is? You just provide the physics simulation with a proper time value, and everything should work fine.

Let's say we have a float tpf that contains the time since the last update. Now, if we want to increase time by the factor 4, we tell the physics engine
that tpf*4 seconds have elapsed since the last update. Since everything gets calculated in relation to this elapsed time, there shouldn't be any
instability, especially not drastically increases stress or torsion. One could even consider calculation 2 physics update with tpf*2 as elapsed time,
each, if the computer running the simulation can handle it.

I'm very curios as to why this doesn't work in KSP. It is being done in other simulators and games (as long as the time step doesn't get too big, which
ofc introduces other forms of instability).

#6 - 09/21/2015 02:47 PM - Squelch
- Is duplicate of Bug #3876: Speeding up the game speed causes the physics to intensify. added

#7 - 09/21/2015 04:04 PM - gsonnenf

Right, even if you don't change the size of the time step, which is the most reasonable way to do this, couldn't at least multiply the modulus of
elasticity and the material strength by the increase in force? If your going to do a physics hack of just 'multiplying physical parameters' to approximate
increased time, you might as well do it all the relevant ones.

| do imagine its harder than just multiplying the elastic modulus (i believe drag is v*2 in your program etc) but anyone with a science degree and who
knows whats in your physics engine should be able to solve for the multiplying function in less than 10 minutes (and i'm being generous).

#8 - 09/21/2015 07:16 PM - Squelch
- Tracker changed from Bug to Feedback

- Status changed from Not a Bug to Duplicate

Adequate warning of the consequences of exceeding the physics capabilities is given to the player. If those warnings are ignored, then it is difficult to
justify as a bug.

As to the whys and wherefores about the current implementation, please direct your discussion to the proper place, the forums, where I'm certain the
topic can be expanded upon, and conclusions drawn.

This issue has been set to feedback as it has rightly become.
